widget_k3git/forum/urls.py
from django.contrib import admin
from django.urls import path

from .views import index, ForumPostDetailView, ForumPostCreateView, ForumPostUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('forumposts/<int:pk>/details', ForumPostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add', ForumPostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit', ForumPostUpdateView.as_view(), name='forumpost-edit'),
]

app_name = "forum"

widget_k3git/widget_k3git/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('announcements/', include('announcement.urls', namespace="announcement")),
    path('calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('dashboard/', include('dashboard.urls', namespace="dashboard")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('admin/', admin.site.urls),
]

widget_k3git/forum/models.py
from django.db import models
from django.urls import reverse


class ForumPost(models.Model):
    title = models.CharField(max_length=100)
    body = models.TextField(max_length=1000)
    author = models.CharField(max_length=100)
    pub_datetime = models.DateTimeField()

    def __str__(self):
        return '{} by {}'.format(self.title, self.author)

    def get_absolute_url(self):
        return reverse('forum:forumpost-details', kwargs={'pk': self.pk})


class Reply(models.Model):
    body = models.TextField(max_length=1000)
    author = models.CharField(max_length=100)
    pub_datetime = models.DateTimeField()
    forum_post = models.ForeignKey(ForumPost, on_delete=models.CASCADE)

    def __str__(self):
        return '{}\'s reply to {}'.format(self.author, self.forum_post)


# Create your models here.

widget_k3git/forum/views.py
from django.shortcuts import render
from django.http import HttpResponse
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import ForumPost, Reply


def index(request):
    return render(request, 'forum/forum.html', {'forumposts': ForumPost.objects.all()})


class ForumPostDetailView(DetailView):
    model = ForumPost

    def get(self, request, pk):
        return render(request, 'forum/forumpost-details.html', {'forum_post': self.model.objects.get(pk=pk)})


class ForumPostCreateView(CreateView):
    model = ForumPost
    fields = '__all__'
    template_name = 'forum/forumpost-add.html'


class ForumPostUpdateView(UpdateView):
    model = ForumPost
    fields = '__all__'
    template_name = 'forum/forumpost-edit.html'

# Create your views here.

widget_k3git/forum/templates/forum/forum.html
{% extends 'base.html' %}

{% block title %}Widget's Forum{% endblock %}
{% block content %}
<h1>Welcome to Widget's Forum!</h1>
<h3>
	{% for post in forumposts %}
		<a href="{{ post.get_absolute_url }}">{{ post.title }} by {{ post.author }}</a><br>
	{% endfor %}
</h3>
{% endblock %}
{% block scripts %}
<a href="/forum/forumposts/add"><input type="submit" value="New Post"></a><br><br>
<a href="/dashboard">Dashboard</a><br>
<a href="/announcements">Announcements</a><br>
<a href="/assignments">Assignments</a><br>
<a href="/calendar">Calendar</a>
{% endblock %}

widget_k3git/forum/templates/forum/forumpost-add.html
{% extends 'base.html' %}

{% block title %}Add Post{% endblock %}
{% block content %}
<h1>Add a new Post:</h1>
<form action="" method="post">
	{% csrf_token %}
	{{ form.as_p }}
	<input type="submit" value="Save New Post">
</form>
{% endblock %}
{% block scripts %}

{% endblock %}

widget_k3git/forum/templates/forum/forumpost-details.html
{% extends 'base.html' %}

{% block title %}{{ forum_post.title }}{% endblock %}
{% block content %}
<h1>{{ forum_post.title }}</h1>
<h3>by {{ forum_post.author }}<br>
    {{ forum_post.pub_datetime }}<br>
    {{ forum_post.body }}<br>
</h3>
<br>
<h1>POST REPLIES</h1>
<h3>
    {% for reply in forum_post.reply_set.all %}
        by {{ reply.author }}
        {{ reply.pub_datetime }}
        {{ reply.body }}
    {% endfor %}
</h3>
{% endblock %}
{% block scripts %}
<a href="/forum/forumposts/{{ forum_post.pk }}/edit"><input type="submit" value="Edit Post"></a>
{% endblock %}

widget_k3git/forum/templates/forum/forumpost-edit.html
{% extends 'base.html' %}

{% block title %}Edit Post{% endblock %}
{% block content %}
<h1>Edit Post:</h1>
<form action="" method="post">
	{% csrf_token %}
	{{ form.as_p }}
	<input type="submit" value="Save Changes to Post">
</form>
{% endblock %}
{% block scripts %}

{% endblock %}